package ch.psi.daq.queryrest.response.json;

import java.io.OutputStream;

import javax.servlet.ServletResponse;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.databind.ObjectMapper;

import ch.psi.daq.domain.backend.Backend;
import ch.psi.daq.queryrest.response.AbstractHTTPResponse;
import ch.psi.daq.queryrest.response.ResponseFormatter;
import ch.psi.daq.queryrest.response.ResponseStreamWriter;

/**
 * Takes a Java 8 stream and writes it to the output stream provided by the {@link ServletResponse}
 * of the current request.
 */
public abstract class AbstractResponseStreamWriter implements ResponseStreamWriter {

   protected void init(final Backend backend) {}

   @Override
   public <R> void respond(
         final Object query,
         final R result,
         final OutputStream out,
         final AbstractHTTPResponse response,
         final ResponseFormatter<R> formatter) throws Exception {
      formatter.format(getJsonFactory(), getObjectMapper(), result, out, response);

      // if (query instanceof DAQQueries) {
      // DAQQueriesResponseFormatter.respond(getJsonFactory(), getObjectMapper(),
      // defaultEventResponseAggregations,
      // (List<Entry<DAQQueryElement, Stream<Triple<BackendQuery, ChannelName, ?>>>>) result,
      // out, response);
      // } else if (query instanceof DAQConfigQuery) {
      // DAQChannelConfigurationQueryResponseWriter.respond(getJsonFactory(), getObjectMapper(),
      // (Entry<DAQConfigQueryElement, Stream<Triple<BackendQuery, ChannelName, ?>>>) result,
      // out, response);
      // } else {
      // AnyResponseWriter.respond(getJsonFactory(), getObjectMapper(), result, out, response,
      // defaultEventFields,
      // defaultConfigFields);
      // }
   }

   protected abstract JsonFactory getJsonFactory();

   protected abstract ObjectMapper getObjectMapper();
}
